/*
******************************************************************************
*
*      File             : tfo_decision.h
*      Version          : 2.0.0
*      Date             : 15 November 2000
*      Author           : Jochen Junkawitsch
*      Description      : header file for TFO decision algorithm
*
*
******************************************************************************
*/

#ifndef TFO_DECISION_H_INCLUDED
#define TFO_DECISION_H_INCLUDED

#include "oacs.h"

typedef struct
{
  CodecSet lscs;
  CodecSet lacs;
  int lmacs;
  CodecType lType;
  int lOM;
  CodecSet dscs;
  CodecSet dacs;
  int dmacs;
  CodecType dType;
  int dOM;

  CodecSet oacs;
  CodecSet cscs;
  CodecSet cacs;
  int cmacs;
  
} Data;



int      tfo_decision_main           (Data* data);
int      tfo_decision_AMR            (Data* data);

int      immediate_TFO               (Data* data);
int      codec_mismatch_resolution   (Data* data);
int      change_to_OACS              (Data* data);
int      codec_mode_optimization     (Data* data);
int      FR_HR_optimization          (Data* data);

int      determine_OACS              (Data* data);
int      determine_IACS              (Data* data);
int      acceptable                  (Data* data, CodecSet cs);
int      FR_HR_matching              (Data* data);
int      contiguous_subset           (CodecSet a, CodecSet b);
int      calc_OACS_case1             (Data* data);
int      calc_OACS_case2             (Data* data);
CodecSet contiguous_subset_selection (CodecSet cs, int lOM, int dOM,
				      CodecSet lacs, CodecSet dacs, int cmacs);
char*    modeName                    (CodecMode m);
char*    codecName                   (CodecType t);

#endif

